#!/usr/bin/python3

import sys
import os

sys.path.insert(0, "/home/caramellaio/code/RunlimPlotGenerator/src")

OLD_OCRA = "old_ocra"
OPT_REWRITING = "opt rewriting"
OLD_REWRITING = "old rewriting"

def file2par(fname):
    str_v = fname.split('_')[-2]

    return int(str_v)

def file2comp(fname):
    fname = os.path.basename(fname)

    return OLD_REWRITING if OLD_OCRA in fname else OPT_REWRITING

if __name__ == "__main__":
    import runlim2py
    import plot

    final = runlim2py.expeval2py(os.getcwd(), "ROD", True)

    plot_obj = plot.gen_obj_vals_from_runlim_obj(final, file2par, file2comp, True, 14400)

    plot.single_param_plot(plot_obj, ["#n RODS", "time (sec)"], "ROD experimental evaluation", 14400, "ROD.png")
    print(plot_obj)

