#!/usr/bin/python3

import sys
import os

sys.path.insert(0, "/home/caramellaio/code/RunlimPlotGenerator/src")

OLD_OCRA = "old_ocra"
NEW_OCRA = "new_ocra"
SMV_OCRA = "smv"
OPT_OCRA = "ltl"

OPT_REWR = "opt rewr"
OLD_REWR = "old rewr"
NEW_REWR = "new rewr"
SMV_REWR = "smv rewr"

def file2par(fname):
    str_v = fname.split('_')[-4].split('-')[0].split('/')[1]

    return int(str_v)

def file2par2(fname):
    return os.path.basename(fname)

def file2comp(fname):
    fname = os.path.basename(fname)

    if OLD_OCRA in fname:
        return OLD_REWR
    elif NEW_OCRA in fname:
        return NEW_REWR
    elif OPT_OCRA in fname:
        return OPT_REWR
    elif SMV_OCRA in fname:
        return SMV_REWR
    else:
        print("Invalid file name: %s" % fname)
        exit(1)

if __name__ == "__main__":
    import runlim2py
    import plot

    final = runlim2py.expeval2py( os.getcwd(), "discr exp eval", True)
    print(final)

