#define W(a, b) (G (a) | ((a) U (b)))

#define absence0(P) (G !(P))
#define absence1(P, R) (F R -> (!P U R))
#define absence2(P, Q) (G (Q -> G(!P)))
#define absence3(P, Q, R) (G((Q & F R) -> !P U R))
#define absence4(P, Q, R) (G (Q -> !P U (R | G (!P))))

#define existence0(P) (F (P))
#define existence1(P, R) (F R -> (!R U P))
#define existence2(P, Q) (G (!Q) | F(Q & F (P)))
#define existence3(P, Q, R) (G((Q & F R) -> (!R U P)))
#define existence4(P, Q, R) (G (Q -> (!R U P)))

#define boundedex0(P) (W (!P, W (P, W(!P, W(P, G !P)))))
#define boundedex1(P, R) (F R -> ((!P & !R) U (R | ((P & !R) U \
         (R | ((!P & !R) U (R | ((P & !R) U \
            (R | (!P U R))))))))))
#define boundedex2(P, Q) (F Q -> (!Q U (Q & (W(!P, W(P, W(!P, W(P, G !P))))))))
#define boundedex3(P, Q, R) (G ((Q & F R) ->  \
   ((!P & !R) U (R | ((P & !R) U          \
     (R | ((!P & !R) U (R | ((P & !R) U   \
       (R | (!P U R)))))))))))
#define boundedex4(P, Q, R) (\
G (Q -> ((!P & !R) U (R | ((P & !R) U \
          (R | ((!P & !R) U (R | ((P & !R) U\
            (R | (!P W R) | G P))))))))))

#define universality0(P) (G (P))
#define universality1(P, R) (F R -> (P U R))
#define universality2(P, Q) (G (Q -> G(P)))
#define universality3(P, Q, R) (G((Q & F R) -> P U R))
#define universality4(P, Q, R) (G (Q -> P U (R | G (P))))

#define response0(P, S) (G (P -> F S)
#define response1(P, R, S) ((P -> (!R U S)) U (R | G (!R)))
#define response2(P, Q, S) (G (Q -> G(P -> F S )))
#define response3(P, Q, R, S) (G((Q & F R) -> (P -> (!R U S)) U R)
#define response4(P, Q, R, S) (G(Q -> ((P -> (!R U S)) U R) | G(P -> (!R U S))))

#define responsechain0(P, S, T) (G (S & X F T -> X (F (T & F P))))
#define responsechain1(P, R, S, T) (F R -> (S & X(!R U T) -> X (!R U (T & F P))) U R)
#define responsechain2(P, Q, S, T) (G (Q -> G (S & X F T -> X(!T U (T & F P)))) )
#define responsechain3(P, Q, R, S, T) (G ((Q & F R) -> (S & X(!R U T) -> X(!R U (T & F P))) U R))
#define responsechain4(P, Q, R, S, T) (G (Q -> (S & X(!R U T) -> X(!R U (T & F P))) U \
    (R | G (S & X(!R U T) -> X(!R U (T & F P))))))

#define constrainedchain0(P, S, T, Z) (G (P -> F(S & !Z & X(!Z U T))) )
#define constrainedchain1(P, R, S, T, Z) (F R -> (P -> (!R U (S & !R & !Z & X((!R & !Z) U T)))) U R )
#define constrainedchain2(P, Q, S, T, Z) (G (Q -> G (P -> (S & !Z & X(!Z U T)))))
#define constrainedchain3(P, Q, R, S, T, Z) (G ((Q & F R) -> (P -> (!R U (S & !R & !Z & X((!R & !Z) U T)))) U R))
#define constrainedchain4(P, Q, R, S, T, Z) (G (Q -> (P -> (!R U (S & !R & !Z & X((!R & !Z) U T)))) U \
    (R | G (P -> (S & !Z & X(!Z U T))))))
